
/***************************************************************************
 *            ho_recognize_font_david.h
 *
 *  Fri Aug 12 20:13:33 2005
 *  Copyright  2005-2008  Yaacov Zamir
 *  <kzamir@walla.co.il>
 ****************************************************************************/

/*  
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/** @file ho_recognize_font_david.h
    @brief libhocr C language header.
    
    libhocr - LIBrary for Hebrew Optical Character Recognition 
*/

#ifndef HO_RECOGNIZE_FONT_DAVID_H
#define HO_RECOGNIZE_FONT_DAVID_H 1

double ho_recognize_font_david_dot (const double *array_in);

double ho_recognize_font_david_comma (const double *array_in);

double ho_recognize_font_david_open (const double *array_in);

double ho_recognize_font_david_close (const double *array_in);

double ho_recognize_font_david_minus (const double *array_in);

double ho_recognize_font_david_plus (const double *array_in);

double ho_recognize_font_david_div (const double *array_in);

double ho_recognize_font_david_tag (const double *array_in);

double ho_recognize_font_david_two_tags (const double *array_in);

double ho_recognize_font_david_question (const double *array_in);

double ho_recognize_font_david_exclem (const double *array_in);

double ho_recognize_font_david_dot_dot (const double *array_in);

double ho_recognize_font_david_dot_comma (const double *array_in);

double ho_recognize_font_david_alef (const double *array_in);

double ho_recognize_font_david_bet (const double *array_in);

double ho_recognize_font_david_gimal (const double *array_in);

double ho_recognize_font_david_dalet (const double *array_in);

double ho_recognize_font_david_hey (const double *array_in);

double ho_recognize_font_david_vav (const double *array_in);

double ho_recognize_font_david_zayin (const double *array_in);

double ho_recognize_font_david_het (const double *array_in);

double ho_recognize_font_david_tet (const double *array_in);

double ho_recognize_font_david_yud (const double *array_in);

double ho_recognize_font_david_caf (const double *array_in);

double ho_recognize_font_david_caf_sofit (const double *array_in);

double ho_recognize_font_david_lamed (const double *array_in);

double ho_recognize_font_david_mem (const double *array_in);

double ho_recognize_font_david_mem_sofit (const double *array_in);

double ho_recognize_font_david_nun (const double *array_in);

double ho_recognize_font_david_nun_sofit (const double *array_in);

double ho_recognize_font_david_samech (const double *array_in);

double ho_recognize_font_david_ayin (const double *array_in);

double ho_recognize_font_david_pey (const double *array_in);

double ho_recognize_font_david_pey_sofit (const double *array_in);

double ho_recognize_font_david_tzadi (const double *array_in);

double ho_recognize_font_david_tzadi_sofit (const double *array_in);

double ho_recognize_font_david_kuf (const double *array_in);

double ho_recognize_font_david_resh (const double *array_in);

double ho_recognize_font_david_shin (const double *array_in);

double ho_recognize_font_david_tav (const double *array_in);

#endif /* HO_RECOGNIZE_FONT_DAVID_H */
